/**
 * Abstract class that provides one abstract method for exponentiation.
 * 
 * @author Tom Verhoeff (TU/e)
 */
public abstract class AbstractPowerClass {
    
    /**
     * Returns exponentiation.
     * 
     * @param a  the base
     * @param b  the exponent
     * @pre {@code 0 <= b}
     * @return {@code a ^ b}
     * @throws IllegalArgumentException  if {@code b < 0}
     */
    public abstract long power(int a, int b) throws IllegalArgumentException;
    
}
