/**
 * Concrete class that computes exponentiation by repeated multiplication.
 * 
 * @author Tom Verhoeff (TU/e)
 */
public class PowerByRepeatedMultiplication extends AbstractPowerClass {
 
    @Override
    public long power(int a, int b) {
        if (b < 0) {
            throw new IllegalArgumentException("power: negative exponent");
        }
        // 0 <= b
        int result = 1;
        int k = 0;
        // invariant: 0 <= k <= b && result == a ^ k 
        while (k != b) {
            result *= a;
            k += 1;
        }
        // result == a ^ b
        return result;
    }
    
}
