import static org.junit.Assert.*;
import org.junit.Test;

/**
 * Abstract test cases for exponentiation, reusable for implementations.
 * Note that these test cases are not applied to AbstractPowerClass,
 * because it is not named AbstractPowerClassTest.
 *
 * @author Tom Verhoeff (TU/e)
 */
public abstract class AbstractPowerClassTestCases {

    /** Implementation under test.  Set by concrete test class. */
    protected AbstractPowerClass instance;

    /**
     * Test of power method, of class AbstractPowerClass.
     */
    @Test
    public void testPowerZero() {
        int a = 1;
        int b = 0;
        System.out.println("power(" + a + ", " + b + ")");
        long expResult = 1;
        long result = instance.power(a, b);
        assertEquals("result", expResult, result);
    }

    /**
     * Test of power method, of class AbstractPowerClass.
     */
    @Test
    public void testPowerOne() {
        int a = 2;
        int b = 1;
        System.out.println("power(" + a + ", " + b + ")");
        long expResult = 2;
        long result = instance.power(a, b);
        assertEquals("result", expResult, result);
    }

    /**
     * Test of power method, of class AbstractPowerClass.
     */
    @Test
    public void testPowerTwo() {
        int a = 3;
        int b = 2;
        System.out.println("power(" + a + ", " + b + ")");
        long expResult = 9;
        long result = instance.power(a, b);
        assertEquals("result", expResult, result);
    }

    /**
     * Test of power method, of class AbstractPowerClass.
     */
    @Test(timeout = 1000)
    public void testPowerTwoLarge() {
        int a = 2;
        int b = 62;
        System.out.println("power(" + a + ", " + b + ")");
        long expResult = Long.MAX_VALUE / 2 + 1;
        long result = instance.power(a, b);
        assertEquals("result", expResult, result);
    }

}
